Updates to Using the NETCONF Protocol over Transport Layer Security (TLS) with Mutual X.509 Authentication
RFC 9918
Sean Turner
sn3rd
sean@sn3rd.com
Russ Housley
Vigil Security, LLC
516 Dranesville Road
Herndon
VA
20170
United States of America
housley@vigilsec.com
January 2026
OPS
netconf
NETCONF
TLS 1.3
TLS 1.2
Early Data
RFC 7589 defines how to protect Network Configuration Protocol (NETCONF) messages with TLS 1.2. This document updates RFC 7589 to update support requirements for TLS 1.2 and add TLS 1.3 support requirements, including restrictions on the use of TLS 1.3's early data.
Introduction
[RFC7589] defines how to protect NETCONF messages [RFC6241] with TLS 1.2 [RFC5246]. This document updates [RFC7589] to update support requirements for TLS 1.2 [RFC5246] and add TLS 1.3 [RFC9846] support requirements, including restrictions on the use of TLS 1.3's early data, which is also known as 0-RTT data. It also updates "netconf tls", the IANA-registered port number entry, to refer to this document. All other provisions set forth in [RFC7589] are unchanged, including connection initiation, message framing, connection closure, certificate validation, server identity, and client identity.
NOTE: Implementations that support TLS 1.3 [RFC9846] SHOULD also follow Sections 4 and 5 of [RFC7589].
Conventions
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Early Data
Early data (aka 0-RTT data) is a mechanism defined in TLS 1.3 [RFC9846] that allows a client to send data ("early data") as part of the first flight of messages to a server. Note that TLS 1.3 can be used without early data as per Appendix F.5 of [RFC9846]. In fact, early data is permitted by TLS 1.3 only when the client and server share a Pre-Shared Key (PSK), either obtained externally or via a previous handshake. The client uses the PSK to authenticate the server and to encrypt the early data.
As noted in Section 2.3 of [RFC9846], the security properties for early data are weaker than those for subsequent TLS-protected data. In particular, early data is not forward secret, and there is no protection against the replay of early data between connections. Appendix F.5 of [RFC9846] requires applications not use early data without a profile that defines its use. This document specifies that NETCONF implementations that support TLS 1.3 or later MUST NOT use early data.
Cipher Suites
Implementations MUST support mutually authenticated TLS 1.2 [RFC5246], and they are, as specified in [RFC9325], recommended to support the cipher suites found in Section 4.2 of [RFC9325].
Implementations MAY implement additional TLS 1.2 cipher suites that provide mutual authentication [RFC5246] and confidentiality, as required by NETCONF [RFC6241].
Implementations SHOULD support mutually authenticated TLS 1.3 [RFC9846] and, if implemented, MUST prefer to negotiate TLS 1.3 over earlier versions of TLS.
Implementations that support TLS 1.3 [RFC9846] are REQUIRED to support the mandatory-to-implement cipher suites listed in Section 9.1 of [RFC9846].
Implementations that support TLS 1.3 MAY implement additional TLS cipher suites that provide mutual authentication and confidentiality, which are required for NETCONF [RFC6241].
Security Considerations
The security considerations of [RFC6241], [RFC7589], and [RFC9325] apply here as well.
NETCONF implementations SHOULD follow the TLS recommendations given in [RFC9325].
For implementations that support TLS 1.3, the security considerations of TLS 1.3 [RFC9846] apply.
As specified in [RFC7589], NETCONF over TLS requires mutual authentication.
For implementations that support TLS 1.3 [RFC9846]:
TLS 1.3 mutual authentication is used to ensure that only authorized users and systems are able to view the NETCONF server's configuration and state or to modify the NETCONF server's configuration. To this end, neither the client nor the server should establish a NETCONF over TLS 1.3 connection with an unknown, unexpected, or incorrectly identified peer; see Section 7 of [RFC7589]. If deployments make use of a trusted list of Certification Authority (CA) certificates [RFC5280], then the listed CAs should only issue certificates to parties that are authorized to access the NETCONF servers. Doing otherwise will allow certificates that were issued for other purposes to be inappropriately accepted by a NETCONF server.
The security considerations of [RFC9525] apply to all implementations when the client checks the identity of the server, as is required in Section 6 of [RFC7589].
IANA Considerations
IANA has added a reference to this document in the "netconf-tls" entry in the "Service Name and Transport Protocol Port Number Registry". The updated registry entry appears as follows:
Service Name:
netconf-tls
Port Number:
6513
Transport Protocol:
tcp
Description:
NETCONF over TLS
Assignee:
IESG <iesg@ietf.org>
Contact:
IETF Chair <chair@ietf.org>
Reference:
RFC 7589, RFC 9918
Normative References
[RFC9846]

The Transport Layer Security (TLS) Protocol Version 1.3
Eric Rescorla
Independent
January 2026
RFC 9846
DOI 10.17487/RFC9846
[RFC7589]
[RFC6241]
[RFC5246]
[RFC2119]
[RFC8174]
[RFC9325]
[RFC5280]
[RFC9525]
Acknowledgments
We would like to thank Per Andersson, Jürgen Schönwälder, Jeff Hartley, Rob Wilton, and Qin Wu for their reviews.